#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>


#define DASM_CHECKS

#define Dst		state
#define Dst_DECL	my_State *Dst
#define Dst_REF		(state->D)
#define DASM_FDEF	static

struct dasm_State;

typedef struct my_State {
  struct dasm_State *D;
} my_State;


#include "dasm_proto.h"

#include "dasm_x86.h"

#include "testdasm.h"


int main(int argc, char **argv)
{
  void *glob[GLOB__MAX];
  my_State state_buf;
  my_State *state = &state_buf;
  void *mcode = NULL;
  size_t sz;
  int status = 0;

  dasm_init(Dst, DASM_MAXSECTION);
  dasm_setupglobal(Dst, glob, GLOB__MAX);
  dasm_setup(Dst, my_actionlist);
  dasm_growpc(Dst, 1);

  gencode(Dst);

  do {
#ifdef DASM_CHECKS
    if ((status = dasm_checkstep(Dst, DASM_SECTION_CODE))) break;
#endif

    if ((status = dasm_link(Dst, &sz))) break;

    mcode = malloc(sz);
    if ((status = dasm_encode(Dst, mcode))) break;

    (void)dasm_getpclabel;

    {
      FILE *fp = fopen("distmp.tmp", "wb");
      fwrite(mcode, 1, sz, fp);
      fclose(fp);
      system("objdump -m i386 -M intel -b binary -D distmp.tmp; rm distmp.tmp");
    }
  } while (0);

  if (status) fprintf(stderr, "DynASM error: %08x\n", status);
  dasm_free(Dst);
  if (mcode) free(mcode);

  return status ? 1 : 0;
}

